# which.gb

Just a little Game Boy ROM which tries to determine which model/revision your device is.  

It makes use of register values at boot, PPU quirks, and APU quirks that differ between device revisions.

## Limitations

It might not be perfect. Let me know if your device is detected incorrectly!

Currently it cannot discern between DMG-CPU A, B and C revisions, nor can it discern between CGB CPU A and B revisions. 

## Release Notes

v0.2.1

- Fix for some "CPU CGB" devices incorrectly reporting as "CPU CGB A/B"

v0.2

- Add support for discerning between CPU CGB A/B and C revisions

## Credits

- Thanks to authors of [Gameboy sound hardware](https://gbdev.gg8.se/wiki/articles/Gameboy_sound_hardware) on the Gameboy Development Wiki.
- Thanks to Lior Halphon (LIJI32) for his [`channel_1_sweep_restart_2.gb`](https://github.com/LIJI32/SameSuite/blob/master/apu/channel_1/channel_1_sweep_restart_2.asm) test ROM from SameSuite.
- Thanks to Joonas Javanainen (gekkio) for his [mooneye-gb](https://github.com/Gekkio/mooneye-gb/) test ROMs which document the register values at boot.
- Written by Matt Currie. 

## License

MIT License. See included LICENSE file for details.
